<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { Hero } from '../components/devsecops/index.vue';
import { NextStep as FeaturesCTA } from '../components/common/index.vue';
import ContentCard from '../components/solutions/by-solution/by-solution-link.vue';
import { getPageMetadata } from '~/common/meta';
import { UseLiteVimeo, UseLocalizedVideoSubtitles } from '~/mixins';

export default Vue.extend({
  components: {
    Hero,
    FeaturesCTA,
    ContentCard,
  },
  mixins: [UseLiteVimeo, UseLocalizedVideoSubtitles],
  async asyncData({ $content, i18n }) {
    try {
      const data = await $content(
        `${i18n.locale}/getting-started-videos`,
      ).fetch();
      return { data };
    } catch (e) {
      throw new Error(e);
    }
  },
  data() {
    return {};
  },
  head(): MetaInfo {
    return getPageMetadata(
      (this as any).data,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },
});
</script>

<template>
  <div class="getting-started-videos">
    <SlpContainer>
      <SlpContainer>
        <component
          :is="component.name"
          v-for="component in data.components"
          :key="component.name"
          :data="component.data"
          v-bind="component"
        />
      </SlpContainer>
      <SlpSideNavigation
        :data="data.side_menu"
        :class="'side-navigation--w-hero'"
      >
        <template #footer>
          <SlpButton>
            {{ data.button.text }}
          </SlpButton>
        </template>
        <SlpContainer>
          <component
            :is="component.name"
            v-for="(component, index) in data.side_menu.content"
            :key="component.name + `-${index}`"
            :data="component.data"
          />
        </SlpContainer>
        <section
          v-for="video in data.videos"
          :id="video.id"
          :key="video.title"
          class="getting-started-videos__video"
        >
          <SlpTypography variant="heading4-bold" tag="h2">
            {{ video.title }}
          </SlpTypography>
          <div class="getting-started-videos__video-wrapper">
            <lite-vimeo
              v-if="video"
              :videoid="getVimeoVideoId(createVideoSource(video.url))"
              autoplay
            ></lite-vimeo>
          </div>
          <SlpButton
            href="/resources/"
            variant="secondary"
            class="getting-started-videos__cta"
            :data-ga-name="video.title.toLowerCase()"
            data-ga-location="body"
            >{{ $t('resources') }}</SlpButton
          >
          <SlpHorizontalRule class="slp-mt-64" />
        </section>
      </SlpSideNavigation>
    </SlpContainer>
    <SlpContainer class="getting-started-videos__footer">
      <ContentCard :data="data.card.data" />
      <FeaturesCTA />
    </SlpContainer>
  </div>
</template>

<style lang="scss" scoped>
:deep #collapsible-sidebar {
  &::-webkit-scrollbar {
    display: none;
  }
  scrollbar-width: none;
  -ms-overflow-style: none;

  &-wrapper {
    justify-content: space-between;
  }

  .anchor {
    margin-bottom: 0;
  }
}

.getting-started-videos {
  overflow-x: clip;
  &__video {
    position: relative;
    padding: $spacing-64 0 0 0;

    &:first-of-type {
      padding: $spacing-24 0 $spacing-64;
    }
  }
  &__cta {
    border: 1px solid;
    &:hover {
      border: 1px solid;
    }
  }

  &__footer {
    margin-top: $spacing-96;

    :deep .slp-icon {
      &:first-of-type {
        display: none;
      }
    }
  }

  &__video-wrapper {
    position: relative;
    overflow: hidden;
    margin: 24px 0;
    width: 100%;
  }
}
</style>
